# coding: utf8

import random as rd
import tkinter
import time
from PIL import Image, ImageTk

points_carte = {'7' : 0, '8' : 0, '9' : 0, 'X' : 10, 'V' : 2, 'D' : 3, 'R' : 4, 'A' : 11}
nom_couleur = {'T' : "trèfle", 'P' : "pique", 'C' : "coeur", 'K' : "carreau", 'V' : "grand"}

valeurs = "789XVDRA"
couleurs = "TPCK"

cartes = [valeur + couleur for valeur in valeurs for couleur in couleurs]


def point(carte):
    return points_carte[carte[0]]

def sous_ensemble(n):
    return rd.sample(cartes, n)

def points(ssens):
    return sum(map(point, ssens))

def plis(n):
    les_plis = []
    melange = rd.sample(cartes, 32)
    for i in range(n):
        possesseur = rd.randint(0, 1)
        les_plis.append((possesseur, melange[3*i:3*i+3]))
    return les_plis

def compte_atouts(pli, atout):
    return sum([carte[0] == "V" or carte[1] == atout for carte in pli])

def comptage(les_plis, atout):
    pts = [0, 0]
    atouts = 0
    for possesseur, pli in les_plis:
        pts[possesseur] += points(pli)
        atouts += compte_atouts(pli, atout)
    return pts, atouts

def entrainement_comptage():
    n = rd.randint(10, 20)
    print("""Vous allez voir passer entre 10 et 20 cartes (ici %d).
Il faudra compter le nombre de points au total."""%n)
    ssens = sous_ensemble(n)
    total = points(ssens)

    for carte in ssens:
        img = Image.open(carte + ".gif")
        imgaff = ImageTk.PhotoImage(img)
        c.delete("all")
        c.create_image(100, 200, image=imgaff)
        c.update()
        time.sleep(.5)

    c.delete("all")
    time.sleep(1)
    Fen.destroy()

    if total == eval(input("Combien de points avez-vous compté ? ")):
        print("Bravo !")
    else:
        print("Erreur, il y en avait", total)


def entrainement_avance():
    n = rd.randint(4, 8)
    print("""Vous allez voir passer entre 4 et 8 plis (ici %d).
Il faudra compter le nombre de points du preneur (plis en vert),
de la défense (plis en rouge) et le nombre d'atouts.
Attention, les plis n'ont pas forcément de cohérence !"""%n)
    les_plis = plis(n)
    atout = rd.choice(couleurs + "V")
    pts, atouts = comptage(les_plis, atout)
    fonds = ["green", "red"]

    print("La couleur d'atout est :", nom_couleur[atout])
    time.sleep(1)

    for possesseur, pli in les_plis:
        for carte in pli:
            img = Image.open(carte + ".gif")
            imgaff = ImageTk.PhotoImage(img)
            c.delete("all")
            c.configure(background=fonds[possesseur])
            c.create_image(100, 200, image=imgaff)
            c.update()
            time.sleep(.5)
        time.sleep(2)

    c.delete("all")
    Fen.destroy()

    a_tester = [pts[0], pts[1], atouts]
    messages1 = ["de points", "de points", "d'atouts"]
    messages2 = ["pour le preneur", "pour la défense", ""]
    for i in range(3):
        if a_tester[i] == eval(input("Combien " + messages1[i] + " avez-vous compté " + messages2[i] + " ? ")):
            print("Bravo !")
        else:
            print("Erreur, il y en avait", a_tester[i])

Fen=tkinter.Tk()
Fen.geometry("300x400")
Fen.config(bg="white")
c=tkinter.Canvas(Fen, bg="green", width=200, height=300)
img = Image.open("trou.gif")
imgaff = ImageTk.PhotoImage(img)
c.create_image(100, 200, image=imgaff)
c.pack()

bouton_comptage = tkinter.Button(Fen, text="Entraînement simple au comptage", command=entrainement_comptage)
bouton_comptage.pack()

bouton_avance = tkinter.Button(Fen, text="Entraînement avancé au comptage", command=entrainement_avance)
bouton_avance.pack()

Fen.mainloop()
